#include<iostream>
#include<cstring>
#include<ezwin.h>
#include<cassert>
#include "rect.h"
#include<ctime>
//#include<Final.cpp>
using namespace std;
SimpleWindow Display_Window("ENTER THE FUNCTION",20.8,18.0);
SimpleWindow MainFunction_Graph_Window("Plot",20.0,20.0);
SimpleWindow Derivative_Window("derivative plot",20.0,20.0);

float F(float x)
{
float y=1/x;
return y;
}

int g=0;
string output="";
int color_change()
{
	Display_Window.StopTimer();
	int u,v,w;
Position ce=Display_Window.GetCenter();

	string A[]= {"1","2","3","+","(",")","log","{}","4","5","6","-","sin","cos","exp","||","7","8","9","*","tan","cot","Pi","[]",".","0","^","/","sec","cosec","x","Enter"};
	w=0;
	for(u=0;u<4;u++)
	{
		for(v=0;v<8;v++)

		{
			if (w!=32)
	    		{
			   Position UL=ce+Position(-8.4+(2.1*v),-5.0+(1.3*u));

               Position LR=ce+Position(-6.4+(2.1*v),-3.8+(1.3*u));

			  Display_Window.RenderRectangle(UL,LR,Blue,Red);

			  Display_Window.RenderText(UL,LR,A[w],Red,Blue);

			   w++;
			}
		}
	}	
}
int derivative_window()
{
		MainFunction_Graph_Window.StopTimer();
	int p1=0,p2=0,p3=0,p4=0,p5=0;
	float a,y,b,p,x,h,k,z,l,f1,f2,s=1,s2=1,x2,a2,y2,z2;
	Derivative_Window.Open();
        assert(Derivative_Window.GetStatus() == WindowOpen);
 	Position c=Derivative_Window.GetCenter(); 
   string A[]={"10","9","8","7","6","5","4","3","2","1","0","-1","-2","-3","-4","-5","-6","-7","-8","-9","-10"};
	for(a=0;a<=20;a++)
  	{
    		Derivative_Window.RenderLine(Position(0.0,a), Position(20.0,a),Magenta, 0.0);
    		Derivative_Window.RenderLine(Position(a,0.0), Position(a,20.0),Magenta,0.0);
	for(int i=0;i<=20;i++)
	{
//y axis
  		Position yaxis=c+Position(-0.2,-9.8+i);
    		Position yul=yaxis+Position(-1.0,-1.0);
    		Position ylr=yaxis+Position(1.0,1.0);
    		Derivative_Window.RenderText(yul,ylr,A[i],Red);
//x axis
    		Position xaxis=c+Position(9.8-i,0.2);
    		Position xul=xaxis+Position(-1.0,-1.0);
    		Position xlr=xaxis+Position(1.0,1.0);
    		Derivative_Window.RenderText(xul,xlr,A[i],Red);
	}	
//Origin
		Position Origin=c+Position(-0.2,0.2);
    		Position Oul=Origin+Position(-1.0,-1.0);
    		Position Olr=Origin+Position(1.0,1.0);
    		Derivative_Window.RenderText(Oul,Olr,"O",Red);
	}
// for drawing the axes  
     Derivative_Window.RenderLine(Position(0.0,10.0), Position(20.0,10.0),Black,0.0);
     Derivative_Window.RenderLine(Position(10.0,0.0), Position(10.0,20.0),Black,0.0);
	for(x=-10;x<=10;x=x+0.0005)
	{
		y=F(x);
			if(y>=-10 && y <=10)
		{
			p1++;
		}
		if(y>=-1 && y<=1)
		{
			p2++;
		}
		if(y>=-0.1 && y<=0.1)
		{
			p3++;
		}
		if(-100<=y && y<=100)
		{
			p4++;
		}
		if(-1000<=y && y<=1000)
		{
			p5++;
		}
		if(x==-10)
		{
			f1=y;
		}
	}

			f2=F(10);

	if(0<p1 && p1<=8000 && p4>8000)
	{
		cout<<p1<<"p1"<<endl;
		s=10;
		AlertWindow("scale change","Y-axis 1cm=10 units");
	}//increase the scale to 10 times 
	else if(0<p1 && p4<8000 && p5>8000)
	{
		cout<<p1<<"p1"<<endl;
		s=100;
                AlertWindow("scale change","Y-axis 1cm=100 units");
	}//increase the scale to 100 times
	else if(p1==0)
   	{
  		if(p4>=8000)
		{
			s=10;
			AlertWindow("scale change","Y-axis 1cm=10 units");
		}
		if(p4<=8000 && p5>=8000)
		{
		s=100;
		AlertWindow("scale change","Y-axis 1cm=100 units");
		}
       	}
	else if((1<=(f1-f2) && (f1-f2)<=2) || (1<=(f2-f1) && (f2-f1)<=2))//see whether this is accepted or not.i mean dt && n || coming 2geder
	{
		if(p2>=8000)
		{
			s=0.1;
			AlertWindow("scale change","Y-axis 1cm=0.1 units");
		}
		else
               {
                    	 s=1;
			 AlertWindow("scale change","Y-axis 1cm=1 unit");
               }												
	}//decrease the scale by 10 times
	else if((0<=(f1-f2) && (f1-f2)<1) || (0<=(f2-f1) && (f2-f1)<1))
	{
		if(p3>8000)
		{
			s=0.01;
			AlertWindow("scale change","Y-axis 1cm=0.01units");
		}
		else
		{
			s=1;
			AlertWindow("scale change","Y-axis 1cm= 1 unit");
		}
	}//decrease the scale by 100 times
	else
	{
		s=1;
		AlertWindow("scale change","scale is : on Y-axis 1cm=1unit");
	}//normal scale

	
//derivative of a function

	for(x=-10;x<=10;x+=0.0005)
	{	
		h=F(x);
		a=x+0.0005;
		b=a+0.0005;
		k=F(a);
		y=(k-h)/0.0005;
		l=F(b);
		z=(l-k)/0.0005;
		/*if(((F(b)==pow(b,p)) && (b==0 ) && (p<0)) || ((F(a)==pow(a,p)) && (a==0) && (p<0)))
		{
			continue;
		}*/
		//if((s==1 && -10<=y && y<=10) || (s==0.01 && -0.1<=y && y<=0.1)|| (s==0.1 && -1<=y && y<=1) || (s==10 && -100<=y && y<=100)|| (s==100 && -1000<=y && y<=1000))
		if(-1000<y && y<1000)
		{
			//x2=x/s2;
			y=y/s;
			//a2=a/s2;
			z=z/s;
			Derivative_Window.RenderLine(Position(10+x,10-y), Position(10+a,10-z),Red,0.0);
                 }
	}
}

int mainfunction_graph_window()
{-
	Display_Window.StopTimer();
	int p1=0,p2=0,p3=0,p4=0,p5=0;
	float a,y,b,p,x,h,k,z,l,f1,f2,s=1,s2=1,x2,b2,y2,h2;
	MainFunction_Graph_Window.Open();
        assert(MainFunction_Graph_Window.GetStatus() == WindowOpen);
  
 	Position c=MainFunction_Graph_Window.GetCenter(); 
   string A[]={"10","9","8","7","6","5","4","3","2","1","0","-1","-2","-3","-4","-5","-6","-7","-8","-9","-10"};
	for(a=0;a<=20;a++)
  	{
    		MainFunction_Graph_Window.RenderLine(Position(0.0,a), Position(20.0,a),Magenta, 0.0);
    		MainFunction_Graph_Window.RenderLine(Position(a,0.0), Position(a,20.0),Magenta,0.0);
	for(int i=0;i<=20;i++)
	{
//y axis
  		Position yaxis=c+Position(-0.2,-9.8+i);
    		Position yul=yaxis+Position(-1.0,-1.0);
    		Position ylr=yaxis+Position(1.0,1.0);
    		MainFunction_Graph_Window.RenderText(yul,ylr,A[i],Red);
//x axis
    		Position xaxis=c+Position(9.8-i,0.2);
    		Position xul=xaxis+Position(-1.0,-1.0);
    		Position xlr=xaxis+Position(1.0,1.0);
    		MainFunction_Graph_Window.RenderText(xul,xlr,A[i],Red);
	}	
//Origin
		Position Origin=c+Position(-0.2,0.2);
    		Position Oul=Origin+Position(-1.0,-1.0);
    		Position Olr=Origin+Position(1.0,1.0);
    		MainFunction_Graph_Window.RenderText(Oul,Olr,"O",Red);
	}
// for drawing the axes  
     MainFunction_Graph_Window.RenderLine(Position(0.0,10.0), Position(20.0,10.0),Black,0.0);
     MainFunction_Graph_Window.RenderLine(Position(10.0,0.0), Position(10.0,20.0),Black,0.0);
	for(x=-10;x<=10;x=x+0.0005)
	{
		y=F(x);
			if(y>=-10 && y <=10)
			{
				p1++;
			}
			if(y>=-1 && y<=1)
			{
				p2++;
			}
			if(y>=-0.1 && y<=0.1)
			{
				p3++;
			}
			if(-100<=y && y<=100)
			{
				p4++;
			}
			if(-1000<=y && y<=1000)
			{
				p5++;
			}
			if(x==-10)
			{
				f1=y;
			}
		}
				f2=F(10);		

		if(0<p1 && p1<=8000 && p4>8000)
	{
		cout<<p1<<"p1"<<endl;
		s=10;
		AlertWindow("scale change","Y-axis 1cm=10 units");
	}//increase the scale to 10 times 
	else if(0<p1 && p4<8000 && p5>8000)
	{
		cout<<p1<<"p1"<<endl;
		s=100;
                AlertWindow("scale change","Y-axis 1cm=100 units");
	}//increase the scale to 100 times
    	else if(p1==0)
	{
		if(p4>=8000)
		{
			s=10;
			AlertWindow("scale change","Y-axis 1cm=10 units");
		}//increase the scale to 10 times
		if(p4<=8000 && p5>=8000)
		{
			s=100;
			AlertWindow("scale change","Y-axis 1cm=100 units");
		}//increase the scale to 100 times
        }
	else if((1<=(f1-f2) && (f1-f2)<=2) || (1<=(f2-f1) && (f2-f1)<=2))
	{
		if(p2>=8000)
		{
			s=0.1;
			AlertWindow("scale change","Y-axis 1cm=0.1 units");
		}//decrease the scale by 10 times
		else
               {
                    	 s=1;
                    	 AlertWindow("scale change","Y-axis 1cm=1 units");
               }//scale remains the same								
	}
	else if((0<=(f1-f2) && (f1-f2)<1) || (0<=(f2-f1) && (f2-f1)<1))
		{
			if(p3>8000)
			{
				s=0.01;
				AlertWindow("scale change","Y-axis 1cm=0.01units");
			}//
			else
			{
				s=1;
				AlertWindow("scale change","Y-axis 1cm= 1 unit");
			}
		}//decrease the scale by 100 times
	else
	{
		s=1;
		AlertWindow("scale change","scale is : on Y-axis 1cm=1unit");
	}//normal scale

	
//plotting the function

	for(x=-10.0;x<=10.0;x+=0.0005)
	{
		y=F(x);
		b=x+0.0005;
		h=F(b);
		y=y/s;
		h=h/s;
		/*if(((F(x)==pow(x,p)) && (x==0)  && (p<0)) || ((F(b)==pow(b,p)) && (b==0) && (p<0)))
		{
			continue;
		}*/	
		//if((s==1  && y<=10) || (s==0.01 && y<=0.1)|| (s==0.1 && y<=1) || (s==10  && y<=100)|| (s==100 && y<=1000))
		if(-1000<y && y<1000)		
		{
			//x2=x/s2;
			//b2=b/s2;
			MainFunction_Graph_Window.RenderLine(Position(10+x,10-y), Position(10+b,10-h),Blue,0.0);
		}
	}
		MainFunction_Graph_Window.SetTimerCallback(derivative_window);
		MainFunction_Graph_Window.StartTimer(3000);
}

int function(const Position &p)
{
	char fn[60];
	int h,m,d=0;
        float x1,y1;
		Position ce=Display_Window.GetCenter();
		Position U1=ce+Position(-7.0,-8.0);
		Position L1=ce+Position(7.0,-6.2);
	char C[]={'1','2','3','+','(',')','l','[','4','5','6','-','s','c','e','M','7','8','9','*','t','a','p',']','.','0','^','/','o','n','x','G'};
string A[]={"1","2","3","+","(",")","log","{}","4","5","6","-","sin","cos","exp","||","7","8","9","*","tan","cot","Pi","[]",".","0","^","/","sec","cosec","x","Enter"};
	    
	x1= p.GetXDistance(); 
	y1= p.GetYDistance();
			for(h=0;h<4;h++)
		{
			for(m=0;m<8;m++)
				{
					Position UL=ce+Position(-8.4+(2.1*m),-5.0+(1.3*h));
              		        	Position LR=ce+Position(-6.4+(2.1*m),-3.8+(1.3*h));						
                     			if(x1>2.0+(2.1*m) && x1<4.0+(2.1*m) &&y1<5.2+(1.3*h) && y1>4+(1.3*h))
						{
							fn[g]=C[d];
							cout<<fn[g];  
                          				g++;
					                Display_Window.RenderRectangle(UL,LR,Black,Red);
			   				Display_Window.RenderText(UL,LR,A[d],Red,Black);
							Display_Window.SetTimerCallback(color_change);
							Display_Window.StartTimer(100);
							if(d==31)
						        {
  								    fn[g-1]='\0';			
									Display_Window.RenderRectangle(U1,L1,Yellow,Red);
		      							Display_Window.SetTimerCallback(mainfunction_graph_window);
									Display_Window.StartTimer(1000);
							 }
							break;
						}
					d++;
				}
		}
output=fn;
Display_Window.RenderText(U1,L1,output,Black,Green);
}

int ApiMain(){
	int u,v,w;
	string A[]= {"1","2","3","+","(",")","log","{}","4","5","6","-","sin","cos","exp","||","7","8","9","*","tan","cot","Pi","[]",".","0","^","/","sec","cosec","x","Enter"};
	Display_Window.Open();
//func enter
	Position ce =Display_Window.GetCenter();
	Position U=ce+Position(-4.0,-9.0);
	Position L=ce+Position(4.0,-8.0);
	Display_Window.RenderText(U,L,"ENTER THE FUNCTION:",Black);
//display
	Position U1=ce+Position(-7.0,-8.0);
	Position L1=ce+Position(7.0,-6.2);
	Display_Window.RenderRectangle(U1,L1,Green,Red);
	
	w=0;
	for(u=0;u<4;u++)
	{
		for(v=0;v<8;v++)

		{
			if (w!=32)
	    	{
			   Position UL=ce+Position(-8.4+(2.1*v),-5.0+(1.3*u));

       		           Position LR=ce+Position(-6.4+(2.1*v),-3.8+(1.3*u));

			   Display_Window.RenderRectangle(UL,LR,Blue,Red);

			   Display_Window.RenderText(UL,LR,A[w],Red,Blue);

			   w++;
			}
		}
	}

string B[]={"s-sine","c-cosine","t-tangent","a-cotanget","o-cosecant","n-secant","M-modulus","p-pi","e-exp"};
	w=0;
	for(u=0;u<3;u++)
	{
		for(v=0;v<3;v++)
		{
			Position Hl=ce+Position(-5.0+(2.8*v),1.5+(1.0*u));
			Position Hr=ce+Position(-2.5+(2.8*v),2.5+(1.0*u));
			Display_Window.RenderText(Hl,Hr,B[w],Magenta,Black);
			w++;	
		}
	}
//mouse click 
	Display_Window.SetMouseClickCallback(function);
}

