#include<iostream>
#include<cstring>
#include<ezwin.h>
#include<cassert>
#include "rect.h"
#include<ctime>
#include<cmath>
#include<cstdio>
using namespace std;
SimpleWindow Welcome_Window("Graph plotter",10.0,15.0);
SimpleWindow Display_Window("ENTER THE FUNCTION",20.8,18.0);
SimpleWindow MainFunction_Graph_Window("Plot of given function",20.0,20.0);
SimpleWindow Derivative_Window("Derivative Plot",20.0,20.0);
int g=0;
string output="";

char fn[60]; //global array for function
char sign;
float x;
float  y=0,cal=0;
int i;
float mult=1.0;
int a[60];  
int counts=1;
bool ext=false;
float mult2=1.0;
float store;
void putsign();
void composition();
void manipulate();
int input(char fn)
{	
	float number(char fn[60],int b);
	void polycomp();
	void power();//substitute for pow
	void signcheck();
	void cosinechk();
	void tanchk();
	void cosecchk();
	void secantchk();
	void cotangent();
	void expchk();
	void modulo();
	void stepchk();
	void swtoothchk();
	void polycheck();
	void logcheck();
	void checkx();
	void constant();

}



float power(float a,float b)//substitute for pow
{if(b==0.0)
   {return 1;}
 float val=a;
 for(int i=1;i<b;i++)
   {val*=a;}
 if(b<0.0){val=(1/a);
          for(int i=1;i<abs(b);i++)
            {val*=(1/a);}
        } 
 return val;
}

float number(char fn[60],int b)
{ float p=0;int c;
 int j=b;
 int digits=1;counts=0;
 
 for(j=b;isdigit(fn[j])&&(fn[j]!='.');j++)
  {     
        c=fn[j]-48;
        p=p*10+c;
        counts++;a[j]=0;
  }
 
 if(fn[j]=='.')
 {j++;counts++;
  while(isdigit(fn[j]))
  {p+=(fn[j]-48)/(power(10,digits));
   j++;
   digits++;counts++;a[j]=0;
  }
  
 }
 return p;
}
void signcheck()
 { if((fn[i]=='+')||(fn[i]=='-')||(fn[i]=='*')||(fn[i]=='/'))      
     {
      sign=fn[i];
      i++;
     
     }    
   
 }





 void sinecheck()
 {
	x=store;
   
   if((fn[i]=='s')&&(fn[i+1]=='(')) //sine
     {i+=2;
      composition();
      i-=2;
      
      if(isdigit(fn[i+2]))
        {mult=number(fn,i+2);
         i+=(2+counts);composition();i-=(2+counts);
        }
        
        //x*=mult;
        cal=sin(store);
        if(mult2!=0){cal*=mult2;}
        a[i]=0;
       if(ext==false){putsign();}
       
      } 
  }








 void cosinechk()
  {x=store;
   if((fn[i]=='c')&&(fn[i+1]=='(')) //cosine
     {i+=2;
      composition();
      i-=2;
      if(isdigit(fn[i+2]))
        {mult=number(fn,i+2);
         i+=(2+counts);composition();i-=(2+counts);
        }
       // x*=mult;
        cal=cos(store);
       if(mult2!=0){cal*=mult2;}
       a[i]=0;
  
     if(ext==false){putsign();}  
  
       }
       
  }
   
  void tanchk()
  {
	x=store;
   if((fn[i]=='t')&&(fn[i+1]=='(')) //tangent
      {i=i+2;
       composition();
       i=i-2;
       if(isdigit(fn[i+2]))
         {mult=number(fn,i+2);
          i+=(2+counts);composition();i-=(2+counts);
         }
         //   x*=mult;
            cal=tan(store);
       if(mult2!=0){cal*=mult2;}
       a[i]=0;
       if(ext==false){putsign();}       
      }
  }
  void cosecchk()
  {
	x=store;
   if((fn[i]=='n')&&(fn[i+1]=='('))//cosecant 
     {i+=2;
      composition();
      i-=2;
      if(isdigit(fn[i+2]))
        {//mult=number(fn,i+2);
         i+=(2+counts);composition();i-=(2+counts);
        }
      
        //x*=mult;
        cal=1/sin(store);
       if(mult2!=0){cal*=mult2;}
        if(ext==false){putsign();}        
       
        a[i]=0;     
      }
  
  }









  
  void secantchk()
  {x=store;
   if((fn[i]=='o')&&(fn[i+1]=='(')) //secant
     {i+=2;
      composition();
      i-=2;
      if(isdigit(fn[i+2]))
        {mult=number(fn,i+2);
         i+=(2+counts);composition();i-=(2+counts);
        }
      
        //x*=mult;
        cal=1/cos(x);
      if(mult2!=0){cal*=mult2;}
      if(ext==false){putsign();} 
        a[i]=0;          
      }
  
  }
  void cotangent()
  {x=store;
   if((fn[i]=='a')&&(fn[i+1]=='(')) //cotangent
     {i+=2;
      composition();
      i-=2;
      if(isdigit(fn[i+2]))
        {mult=number(fn,i+2);
         i+=(2+counts);composition();i-=(2+counts);
        }
   
        x*=mult;
        cal=1/tan(x);
       if(ext==false){putsign();} 
       a[i]=0;
      }
  
  }




 
  void expchk() 
  { x=store;
  if((fn[i]=='e')&&(fn[i+1]=='^')&&(fn[i+2]=='('))//exponent 
     {i+=3;
      composition();
      i-=3;
      if(isdigit(fn[i+3]))
        {mult=number(fn,i+3);
        i+=(3+counts);composition();i-=(3+counts);
        }
       
        //x*=mult;
        cal=pow(3,x);//approx value of e=3 due to compiler restrictions;
      
      if(mult2!=0){cal*=mult2;}
       if(ext==false){putsign();} 
      
       a[i]=0;
  
      }
  }





 
 void powchk()
 {x=store;
  if(isdigit(fn[i]))
   {int temp=i;
    float base;
    base=number(fn,temp); 
    temp+=counts;
    if((fn[temp]=='^')&&(fn[temp+1]=='('))
     {temp+=2;composition();temp-=2;
      cal=power(base,x);
      for(int z=i;z<=temp;z++){a[z]=0;}       
     }
    if(ext==false){putsign();}
   }
   
 } //power function 
 
 
 
 
  
  void modulo()
  {x=store;
   if(fn[i]=='m'&&fn[i+1]=='(')//modulus
   {i+=2;
   composition();
   i-=2;
   if(isdigit(fn[i+2]))
    {mult=number(fn,i+2);
    i+=(2+counts);composition();i-=(2+counts);
    }
    
    x*=mult;
    cal=abs(x);
    if(mult2!=0){cal*=mult2;}
    if(ext==false){putsign();}  
     a[i]=0;
    }
  }
 



 
  void stepchk()
  {x=store;
  if(fn[i]=='[')//step function
  {i++;
   composition();
   i--;
   if(isdigit(fn[i+1]))
    {mult=number(fn,i+1);
    i+=(2+counts);composition();i-=(2+counts);
    }
   
    x*=mult;
     
    int temp;
    if(x>0){temp=x;}
      else
          if(x==0){temp=0;}
            else{temp=x;
                 temp--;}
    cal=temp;
    if(mult2!=0){cal*=mult2;}
    if(ext==false){putsign();} 
   a[i]=0;
  } 
 }
 



 
 void swtoothchk()
 {x=store;
 if(fn[i]=='{')//saw tooth 
   {i++;
   composition();
   i--;
   if(isdigit(fn[i+1]))
    {mult=number(fn,i+1);
    i+=(2+counts);composition();i-=(2+counts);
    }
 
    x*=mult;
    int temp;
   if(x>0){temp=x;}
   
   else{temp=x;
   temp--;}
   cal=x-temp;
   if(mult2!=0){cal*=mult2;}
   if(ext==false){putsign();} 
   a[i]=0;

   }
 }  












void polycheck()
{x=store;
 if((fn[i]=='x')&&(fn[i+1]=='^')&&(isdigit(fn[i+2])))
  {  mult=number(fn,i+2);
     cal=power(x,mult);
     if(mult2!=0){cal*=mult2;}
     a[i]=0;  
     putsign();
    }
     
   
}








void externalmultiplier()
{if(isdigit(fn[i]))
  {
   mult2=number(fn,i);
   ext=true;
   i+=(counts);
  }
   
} 






void logcheck()
{x=store;
   if((fn[i]=='l')&&(fn[i+1]=='(')) //sine
     {i+=2;
      composition();
      i-=2;
      if(isdigit(fn[i+2]))
        {mult=number(fn,i+2);
         i+=(2+counts);composition();i-=(2+counts);
        }
        x*=mult;
        cal=log(x);
        a[i]=0;
       if(ext==false){putsign();}
       
      }  
}
bool chkx=0;





void checkx()
{x=store;
 
if((fn[i]=='x')&&(fn[i-1]!='(')&&(fn[i+1]!=')')&&(fn[i+1]!='^')&&(fn[i-1]!='[')&&(fn[i-1]!='{'))
 {cal=x; 
  if(mult2!=0){cal*=mult2;chkx=1;}
  putsign();
  

} 
}
bool cons=false;float c;int k;






void constant()
{ 
 if(sign=='+'||sign=='-')
  { 
   if(isdigit(fn[i])&&(fn[i+1]!='x'))
    {c=number(fn,i);    
     
     cons=true;
    }       
    for(int z=0,k=i;z<counts;z++,k++)
     {a[k]=0;}

  }
} //constant
bool rc=false;






void rationalcomp()
{
 int g=i;int count =1;
 int possign;char s;
 float dig;
 bool flag2=true;


if((mult2!=1)&&(mult2!=0))   
{count++;}
 if(isdigit(fn[g])){dig=number(fn,g);}


if(((fn[g]=='x')&&(fn[g-counts-1]=='(')&&(fn[g-counts-2]!='m'))||(isdigit(fn[g]))) 
{ 
 if(isdigit(fn[g]))
    {
     x*=dig;
     
    }
 rc=true;
 while(fn[g]!=')')
 {count++;
  if(fn[g]=='^')
    {flag2=false; }
  g++;
 }
 if(fn[count+2]=='+'||fn[count+2]=='-'||fn[count+2]=='*'||fn[count+2]=='/'){flag2=false;}
 if(flag2==true)
 {g-=count;
  while((++g)<=count)
  { if(fn[g]=='+'||fn[g]=='-')     
     {possign=g;s=fn[g];
     if(isdigit(fn[possign+1]))
      { dig=number(fn,possign+1);
       
       mult2*x;
       if(s=='+'){x+=dig;}
       if(s=='-'){x-=dig;}
       
       
      }  
     }
  }    
g-=count; 
for(int u=0;u<=count;u++){fn[u]=0;}
}
 else{x=store;}
}
}
bool pc=false;
void polycomp()
{ int g=i;
  float digit;
  int count=1;
  char sgn;
  int pos;
  float temp;
  bool flag3=true;
  if(isdigit(fn[g]))
  {externalmultiplier();}
  if(fn[g+counts]=='x'&&fn[g+counts+1]=='^'&&isdigit(fn[g+counts+2]))
   {digit=number(fn,g+counts+2);
    
    temp=power(x,digit);
    temp*=mult2;
    mult2=1.0;   
    x=temp;
    pc=true;
   
   } 
   
   while(fn[g]!=')')
   {count++;g++;}
    g-=count;
    if(fn[count+2]=='+'||fn[count+2]=='-'||fn[count+2]=='*'||fn[count+2]=='/'){flag3=false;}
    if(flag3==true)
    {while((++g)<=count)
      { if(fn[g]=='+'||fn[g]=='-')     
          {pos=g;sgn=fn[g];
            if(isdigit(fn[pos+1]))
             { digit=number(fn,pos+1);
               
               
               if(sgn=='+'){x+=digit;}
               if(sgn=='-'){x-=digit;}
       
               
             }  
           }
       }    
     
   g-=count;  
   }
   else{x=store;}
   for(int u=0;u<=count;u++){fn[u]=0;}
       
   }







void putsign()  
 { 

  if(sign=='+')
    {y+=cal;
    
}
    else
        if(sign=='-')
          {y-=cal;
}
          else
              if(sign=='*')
                {y*=cal;
              
                  }
                else
                    if(sign=='/')
                      {y/=cal;}
                     else
                         {y=cal;

}
                           

 }
  


void manipulate()
{ for(int u=0;u<strlen(fn);u++)
  {a[u]=1;}
  i=0;
 while(i<strlen(fn))
   {
   mult=1.0;
  if(a[i]!=0)
   {ext=false;
   externalmultiplier();
   signcheck();
   sinecheck();
   cosinechk();
   tanchk();
   cosecchk();
   secantchk();
   cotangent();
   expchk(); 
   modulo();
   stepchk();
   swtoothchk();
   polycheck();
   logcheck();
   checkx();
   constant();
   
   if((ext==true)&&(cal!=0)&&(chkx!=1)){y=cal;ext=false;
                                        
                                         }  
   cal=cal/mult2;
   if(cons==true)
  {
                  if(sign=='+')
                  {cal+=c;y=cal;}
                  else
                      if(sign=='-')
                       {cal-=c;y=cal;}
                      cons=false; 
                        
   }
   
  
  sign='$';  
  }
  
  i++;
  
}

} 



void composition()
{ int flag=0;
  char sign2; 
  if((sign=='+')||(sign=='-')||(sign=='*')||(sign=='/')){sign2=sign;flag=1;sign='#';} 
   
   sinecheck();
   cosinechk();
   tanchk();
   cosecchk();
   secantchk();
   cotangent();
   expchk();
   modulo();
   stepchk();
   swtoothchk();
   logcheck();
   rationalcomp();
   

 if((cal!=0))
  {
   if(sign=='+')
     {x+=cal;}
    else
       if(sign=='-')
         {x-=cal;}
         else
             if(sign=='*')                
               {x*=cal;}
               else
                  if(sign=='/')
                    {x/=cal;}
                    else
                        if(sign=='#'){
                         x=store;}
                         else 
                            if((rc==true)||(pc==true)){}
                              else
                                 {x=cal;}
                             
   }
     
  if(flag=1){sign=sign2;}    
}



int color_change()
{
	Display_Window.StopTimer();
	int u,v,w;
Position ce=Display_Window.GetCenter();

	string A[]= {"1","2","3","+","(",")","log","{}","4","5","6","-","sin","cos","exp","||","7","8","9","*","tan","cot","Pi","[]",".","0","^","/","sec","cosec","x","Enter"};
	w=0;
	for(u=0;u<4;u++)
	{
		for(v=0;v<8;v++)

		{
			if (w!=32)
	    	{
			   Position UL=ce+Position(-8.4+(2.1*v),-5.0+(1.3*u));

               Position LR=ce+Position(-6.4+(2.1*v),-3.8+(1.3*u));

			   Display_Window.RenderRectangle(UL,LR,Blue,Red);

			   Display_Window.RenderText(UL,LR,A[w],Red,Blue);

			   w++;
			}
		}
	}
	
}
int derivative_window()
{
	MainFunction_Graph_Window.StopTimer();
	int p1=0,p2=0,p3=0,p4=0,p5=0;
	float a,y,b,t,p,x,h,k,z,l,f1,f2,s=1,s2=1,T,Z;
	Derivative_Window.Open();
        assert(Derivative_Window.GetStatus() == WindowOpen);
 	Position Center_Der_W=Derivative_Window.GetCenter();
   string A[]={"10","9","8","7","6","5","4","3","2","1","0","-1","-2","-3","-4","-5","-6","-7","-8","-9","-10"};
	for(a=0;a<=20;a++)
  	{
    		Derivative_Window.RenderLine(Position(0.0,a), Position(20.0,a),Magenta, 0.0);
    		Derivative_Window.RenderLine(Position(a,0.0), Position(a,20.0),Magenta,0.0);
	}
	for(int i=0;i<=20;i++)
	{
//y axis
  		Position yaxis=Center_Der_W+Position(-0.2,-9.8+i);
    		Position yul=yaxis+Position(-1.0,-1.0);
    		Position ylr=yaxis+Position(1.0,1.0);
    		Derivative_Window.RenderText(yul,ylr,A[i],Red);
//x axis
    		Position xaxis=Center_Der_W+Position(9.8-i,0.2);
    		Position xul=xaxis+Position(-1.0,-1.0);
    		Position xlr=xaxis+Position(1.0,1.0);
    		Derivative_Window.RenderText(xul,xlr,A[i],Red);
	}	
//Origin
		Position Origin=Center_Der_W+Position(-0.2,0.2);
    		Position Oul=Origin+Position(-1.0,-1.0);
    		Position Olr=Origin+Position(1.0,1.0);
    		Derivative_Window.RenderText(Oul,Olr,"O",Red);
	
// for drawing the axes  
     Derivative_Window.RenderLine(Position(0.0,10.0), Position(20.0,10.0),Black,0.0);
     Derivative_Window.RenderLine(Position(10.0,0.0), Position(10.0,20.0),Black,0.0);
	for(float x3=-10;x3<=10;x3=x3+0.0005)
	{
		
		store=x3;
		manipulate();
		if(y>=-10 && y <=10)
		{
			p1++;
		}
		if(y>=-1 && y<=1)
		{
			p2++;
		}
		if(y>=-0.1 && y<=0.1)
		{
			p3++;
		}
		if(-100<=y && y<=100)
		{
			p4++;
		}
		if(-1000<=y && y<=1000)
		{
			p5++;
		}
	}
		
		store=-10;
		manipulate();
		f1=y;
				
		store=10;
		manipulate();
		f2=y;
	if(0<p1 && p1<=8000 && p4>8000)
	{
		s=10;
		AlertWindow("scale change","Y-axis 1cm=10 units");
	}//increase the scale to 10 times 
	else if(0<p1 && p4<8000 && p5>8000)
	{
		s=100;
                AlertWindow("scale change","Y-axis 1cm=100 units");
	}//increase the scale to 100 times
	else if(p1==0)
   	{
  		if(p4>=8000)
		{
			s=10;
			AlertWindow("scale change","Y-axis 1cm=10 units");
		}
		if(p4<=8000 && p5>=8000)
		{
		s=100;
		AlertWindow("scale change","Y-axis 1cm=100 units");
		}
       	}
	else if((1<=(f1-f2) && (f1-f2)<=2) || (1<=(f2-f1) && (f2-f1)<=2))//see whether this is accepted or not.i mean dt && n || coming 2geder
	{
		if(p2>=8000)
		{
			s=0.1;
			AlertWindow("scale change","Y-axis 1cm=0.1 units");
		}
		else
               {
                    	 s=1;
			 AlertWindow("scale change","Y-axis 1cm=1 unit");
               }												
	}//decrease the scale by 10 times
	else if((0<=(f1-f2) && (f1-f2)<1) || (0<=(f2-f1) && (f2-f1)<1))
	{
		if(p3>8000)
		{
			s=0.01;
			AlertWindow("scale change","Y-axis 1cm=0.01units");
		}
		else
		{
			s=1;
			AlertWindow("scale change","Y-axis 1cm= 1 unit");
		}
	}//decrease the scale by 100 times
	else
	{
		s=1;
		AlertWindow("scale change","scale is : on Y-axis 1cm=1unit");
	}//normal scale
//derivative of a function

	for(float x4=-10;x4<=10;x4+=0.0005)
	{					
		store=x4;
		manipulate();
		h=cal;
		
		a=x4+0.0005;
		store=a;
		manipulate();
		k=cal;
		t=(k-h)/0.0005;
		b=a+0.0005;
		store=b;
		manipulate();
		l=cal;
		z=(l-k)/0.0005;
		T=t/s;
		Z=z/s;
		if(-1000<t && t<1000)
		{
			Derivative_Window.RenderLine(Position(10+x4,10-T), Position(10+a,10-Z),Red,0.0);
        	}
	}
	
}

int mainfunction_graph_window()
{
	Display_Window.StopTimer();
int p12=0,p22=0,p32=0,p42=0,p52=0;
	float a,V,b,p,h,k,z,l,f11,f12,s;
	MainFunction_Graph_Window.Open();
        assert(MainFunction_Graph_Window.GetStatus() == WindowOpen);

 	Position Center_MGW=MainFunction_Graph_Window.GetCenter(); 
	string A[]={"10","9","8","7","6","5","4","3","2","1","0","-1","-2","-3","-4","-5","-6","-7","-8","-9","-10"};
	for(a=0;a<=20;a++)
  	{
    		MainFunction_Graph_Window.RenderLine(Position(0.0,a), Position(20.0,a),Magenta, 0.0);
    		MainFunction_Graph_Window.RenderLine(Position(a,0.0), Position(a,20.0),Magenta,0.0);
	}
	for(int i1=0;i1<=20;i1++)
	{
//y axis
  		Position yaxis=Center_MGW+Position(-0.2,-9.8+i1);
    		Position yul=yaxis+Position(-1.0,-1.0);
    		Position ylr=yaxis+Position(1.0,1.0);
    		MainFunction_Graph_Window.RenderText(yul,ylr,A[i1],Red);
//x axis
    		Position xaxis=Center_MGW+Position(9.8-i1,0.2);
    		Position xul=xaxis+Position(-1.0,-1.0);
    		Position xlr=xaxis+Position(1.0,1.0);
    		MainFunction_Graph_Window.RenderText(xul,xlr,A[i1],Red);
	}	
//Origin
		Position Origin=Center_MGW+Position(-0.2,0.2);
    		Position Oul=Origin+Position(-1.0,-1.0);
    		Position Olr=Origin+Position(1.0,1.0);
    		MainFunction_Graph_Window.RenderText(Oul,Olr,"O",Red);

// for drawing the axes  
     MainFunction_Graph_Window.RenderLine(Position(0.0,10.0), Position(20.0,10.0),Black,0.0);
     MainFunction_Graph_Window.RenderLine(Position(10.0,0.0), Position(10.0,20.0),Black,0.0);
float x_a=0.0;
	for(x_a=-10.00;x_a<=10.0001;x_a=x_a+0.0005)
		{
			store=x_a;
			manipulate();
			if(y>=-10 && y <=10)
			{
				p12++;
			}
			if(y>=-1 && y<=1)
			{
				p22++;
			}
			if(y>=-0.1 && y<=0.1)
			{
				p32++;
			}
			if(-100<=y && y<=100)
			{
				p42++;
			}
			if(-1000<=y && y<=1000)
			{
				p52++;
			}
		}
			store=-10;
			manipulate();
			f11=y;
			store=10;
			manipulate();
			f12=y;
	if(0<p12 && p12<=8000 && p42>8000)
	{
		s=10;
		AlertWindow("scale change","Y-axis 1cm=10 units");
	}//increase the scale to 10 times 
	else if(0<p12 && p42<8000 && p52>8000)
	{
		s=100;
                AlertWindow("scale change","Y-axis 1cm=100 units");
	}//increase the scale to 100 times
    	else if(p12==0)
	{
		if(p42>=8000)
		{
			s=10;
			AlertWindow("scale change","Y-axis 1cm=10 units");
		}//increase the scale to 10 times
		if(p42<=8000 && p52>=8000)
		{
			s=100;
			AlertWindow("scale change","Y-axis 1cm=100 units");
		}//increase the scale to 100 times
        }
	else if((1<=(f11-f12) && (f11-f12)<=2) || (1<=(f12-f11) && (f12-f11)<=2))
	{
		if(p22>=8000)
		{
			s=0.1;
			AlertWindow("scale change","Y-axis 1cm=0.1 units");
		}//decrease the scale by 10 times
		else
               {
                    	 s=1;
                    	 AlertWindow("scale change","Y-axis 1cm=1 units");
               }//scale remains the same								
	}
	else if((0<=(f11-f12) && (f11-f12)<1) || (0<=(f12-f11) && (f12-f11)<1))
		{
			if(p32>8000)
			{
				s=0.01;
				AlertWindow("scale change","Y-axis 1cm=0.01units");
			}
			else
			{
				s=1;
				AlertWindow("scale change","Y-axis 1cm= 1 unit");
			}
		}//decrease the scale by 100 times
	else
	{
		s=1;
		AlertWindow("scale change","scale is : on Y-axis 1cm=1unit");
	}//normal scale
//plotting the function

	for(float x_x=-10.0;x_x<=10;x_x+=0.0005)
	{	
	
		store=x_x;
		manipulate(); 
 		h=y;
		b=x_x+0.0005;
		store=b;
		manipulate();
		V=y;
		V=V/s;
		h=h/s;	

		if(-1000<h && h<1000)
		{
			MainFunction_Graph_Window.RenderLine(Position(10+x_x,10-h), Position(10+b,10-V),Blue,0.0);
		}
	}
	
		MainFunction_Graph_Window.SetTimerCallback(derivative_window);
		MainFunction_Graph_Window.StartTimer(3000);
}

int mousefunction(const Position &p)
{
	//char fn[60];
	int h,m,f=0;
        float x1,y1;
	Position ce=Display_Window.GetCenter();
	Position U1=ce+Position(-7.0,-8.0);
	Position L1=ce+Position(7.0,-6.2);
									
     /*x,y,n,i,j,k,z,a,b,p are being used again*/   
	char C[]={'1','2','3','+','(',')','l','{','4','5','6','-','s','c','e','M','7','8','9','*','t','a','p','[','.','0','^','/','o','n','x','G'};
string A[]={"1","2","3","+","(",")","log","{}","4","5","6","-","sin","cos","exp","||","7","8","9","*","tan","cot","Pi","[]",".","0","^","/","sec","cosec","x","Enter"};
	x1= p.GetXDistance(); 
	y1= p.GetYDistance();
	int d=0;
	for(h=0;h<4;h++)
	{
		for(m=0;m<8;m++)
		{
			Position UL=ce+Position(-8.4+(2.1*m),-5.0+(1.3*h));
              		Position LR=ce+Position(-6.4+(2.1*m),-3.8+(1.3*h));
                 	if(x1>2.0+(2.1*m) && x1<4.0+(2.1*m) && y1<5.2+(1.3*h) && y1>4+(1.3*h))
			{
				fn[g]=C[f];
       	         		g++;				
				Display_Window.RenderRectangle(UL,LR,Black,Red);
				Display_Window.RenderText(UL,LR,A[f],Red,Black);
				Display_Window.SetTimerCallback(color_change);
				Display_Window.StartTimer(150);
				input(fn[g-1]);				
				if(f==31)
			        {
 				    fn[g-1]='\0';
				    //input(fn[]);
		       	            Display_Window.RenderRectangle(U1,L1,Yellow,Red);
				    Display_Window.SetTimerCallback(mainfunction_graph_window);
				    Display_Window.StartTimer(500);			
				}		
	     			break;				
 	                 
			}							
			f++;		
        	}
	}				    
	output=fn;
        Display_Window.RenderText(U1,L1,output,Red,Green);
}
int display_window()
{
	Welcome_Window.StopTimer();
	int u,v,w;
	string A[]= {"1","2","3","+","(",")","log","{}","4","5","6","-","sin","cos","exp","||","7","8","9","*","tan","cot","Pi","[]",".","0","^","/","sec","cosec","x","Enter"};
	Display_Window.Open();
	
//func enter
	Position ce =Display_Window.GetCenter();
	Position U=ce+Position(-4.0,-9.0);
	Position L=ce+Position(4.0,-8.0);
	Display_Window.RenderText(U,L,"ENTER THE FUNCTION:",Black);
//display
	Position U1=ce+Position(-7.0,-8.0);
	Position L1=ce+Position(7.0,-6.2);
	Display_Window.RenderRectangle(U1,L1,Green,Red);
	
	w=0;
	for(u=0;u<4;u++) 
	{
		for(v=0;v<8;v++)

		{
			if (w!=32)
		    	{
			   Position UL=ce+Position(-8.4+(2.1*v),-5.0+(1.3*u));
		           Position LR=ce+Position(-6.4+(2.1*v),-3.8+(1.3*u));
			   Display_Window.RenderRectangle(UL,LR,Blue,Red);
			   Display_Window.RenderText(UL,LR,A[w],Red,Blue);
			   w++;
			}
		}
	}
string B[]={"s-sine","c-cosine","t-tangent","a-cotanget","o-cosecant","n-secant","M-modulus","p-pi","e-exp"};
	w=0;
	for(u=0;u<3;u++)
	{
		for(v=0;v<3;v++)
		{
			Position Hl=ce+Position(-5.0+(2.8*v),1.5+(1.0*u));
			Position Hr=ce+Position(-2.5+(2.8*v),2.5+(1.0*u));
			Display_Window.RenderText(Hl,Hr,B[w],Magenta,White);
			w++;	
		}
	}
		Welcome_Window.Close();
//mouse click 
	Display_Window.SetMouseClickCallback(mousefunction);
}
int ApiMain()
{
	Welcome_Window.Open();
	Position center_WW=Welcome_Window.GetCenter();
	Position UL_WW=center_WW+Position(-3.0,-5.5);
	Position LR_WW=center_WW+Position(3.0,-3.5);
	Welcome_Window.RenderText(UL_WW,LR_WW,"WELCOME TO THE GRAPH PLOTTER",Black);
	Welcome_Window.RenderText(Position(0.5,4.5),Position(1.5,5.5),"by",Red);
string D[]={"VIBIN ABRAHAM","VISHNU NAIR","SIDDHARTH KHADEPURI","TARUN JHUNJHUNWALA","ZEBA ISLAM","ABHIRAM TARADI"};
	int d=0;
	for(int v=0;v<3;v++)
	{
		for(int w=0;w<2;w++)
		{
			Welcome_Window.RenderText(Position(1.0+5.0*w,6.0+1.5*v),Position(4.0+5.0*w,7.3+1.5*v),D[d],Green);
			d++;
		}
	}
	Welcome_Window.RenderText(Position(2.0,11.0),Position(8.0,12.0),"SAKET KUMAR(T.A.)",Black);
	Welcome_Window.SetTimerCallback(display_window);
	Welcome_Window.StartTimer(100);
}
